# Application Logs

In Coderd, application logs refer to the records of events, messages, and
activities generated by the application during its execution. These logs provide
valuable information about the application's behavior, performance, and any
issues that may have occurred.

Application logs include entries that capture events on different levels of
severity:

- Informational messages
- Warnings
- Errors
- Debugging information

By analyzing application logs, system administrators can gain insights into the
application's behavior, identify and diagnose problems, track performance
metrics, and make informed decisions to improve the application's stability and
efficiency.

## Error logs

To ensure effective monitoring and timely response to critical events in the
Coder application, it is recommended to configure log alerts that specifically
watch for the following log entries:

| Log Level | Module                       | Log message             | Potential issues                                                                                  |
| --------- | ---------------------------- | ----------------------- | ------------------------------------------------------------------------------------------------- |
| `ERROR`   | `coderd`                     | `workspace build error` | Workspace owner is unable to start their workspace.                                               |
| `ERROR`   | `coderd.autobuild`           | `workspace build error` | Autostart failed to initiate the workspace.                                                       |
| `ERROR`   | `coderd.provisionerd-<name>` |                         | The provisioner job encounters issues importing the workspace template or building the workspace. |
| `ERROR`   | `coderd.userauth`            |                         | Authentication problems, such as the inability of the workspace user to log in.                   |
| `ERROR`   | `coderd.prometheusmetrics`   |                         | The metrics aggregator's queue is full, causing it to reject new metrics.                         |
