## Changelog

### Important changes

- [Managed variables](https://coder.com/docs/v2/latest/templates/parameters#terraform-template-wide-variables)
  are enabled by default. The following block within templates is obsolete and
  can be removed from your templates:

  ```diff
  provider "coder" {
  -  feature_use_managed_variables = "true"
  }
  ```

  > The change does not affect your templates because this attribute was
  > previously necessary to activate this additional feature.

- Our scale test CLI is
  [experimental](https://coder.com/docs/v2/latest/contributing/feature-stages#experimental-features)
  to allow for rapid iteration. You can still interact with it via
  `coder exp scaletest` (#8339)

### Features

- [coder dotfiles](https://coder.com/docs/v2/latest/cli/dotfiles) can checkout a
  specific branch

### Bug fixes

- Delay "Workspace build is pending" banner to avoid quick re-render when a
  workspace is created (#8309)
- `coder stat` handles cgroups with no limits
- Remove concurrency to allow migrations when `coderd` runs on multiple replicas
  (#8353)
- Pass oauth configs to site (#8390)
- Improve error message for missing action in Audit log (#8335)
- Add missing fields to extract api key config (#8393)
- Resize terminal when alert is dismissed (#8368)
- Report failed CompletedJob (#8318)
- Resolve nil pointer dereference on missing oauth config (#8352)
- Update fly.io example to remove deprecated parameters (#8194)

Compare:
[`v0.25.0...0.26.0`](https://github.com/coder/coder/compare/v0.25.0...v0.26.0)

## Container image

- `docker pull ghcr.io/coder/coder:v0.26.0`

## Install/upgrade

Refer to our docs to [install](https://coder.com/docs/v2/latest/install) or
[upgrade](https://coder.com/docs/v2/latest/admin/upgrade) Coder, or use a
release asset below.
