## Changelog

### Breaking changes

Agent logs can be pushed after a workspace has started (#8528)

> ⚠️ **Warning:** You will need to
> [update](https://coder.com/docs/v2/latest/install) your local Coder CLI v0.27
> to connect via `coder ssh`.

### Features

- [Empeheral parameters](https://registry.terraform.io/providers/coder/coder/latest/docs/data-sources/parameter#ephemeral)
  allow users to specify a value for a single build (#8415) (#8524)
  ![Ephemeral parameters](https://github.com/coder/coder/assets/22407953/89df0888-9abc-453a-ac54-f5d0e221b0b9)
  > Upgrade to Coder Terraform Provider v0.11.1 to use ephemeral parameters in
  > your templates
- Create template, if it doesn't exist with `templates push --create` (#8454)
- Workspaces now appear `unhealthy` in the dashboard and CLI if one or more
  agents do not exist (#8541) (#8548)
  ![Workspace health](https://github.com/coder/coder/assets/22407953/edbb1d70-61b5-4b45-bfe8-51abdab417cc)
- Reverse port-forward with `coder ssh -R` (#8515)
- Helm: custom command arguments in Helm chart (#8567)
- Template version messages (#8435)
  <img width="428" alt="252772262-087f1338-f1e2-49fb-81f2-358070a46484" src="https://github.com/coder/coder/assets/22407953/5f6e5e47-e61b-41f1-92fe-f624e92f8bd3">
- TTL and max TTL validation increased to 30 days (#8258)
- [Self-hosted docs](https://coder.com/docs/v2/latest/install/offline#offline-docs):
  Host your own copy of Coder's documentation in your own environment (#8527)
  (#8601)
- Add custom coder bin path for `config-ssh` (#8425)
- Admins can create workspaces for other users via the CLI (#8481)
- `coder_app` supports localhost apps running https (#8585)
- Base container image contains [jq](https://github.com/coder/coder/pull/8563)
  for parsing mounted JSON secrets

### Bug fixes

- Check agent metadata every second instead of minute (#8614)
- `coder stat` fixes
  - Read from alternate cgroup path (#8591)
  - Improve detection of container environment (#8643)
  - Unskip TestStatCPUCmd/JSON and explicitly set --host in test cmd invocation
    (#8558)
- Avoid initial license reconfig if feature isn't enabled (#8586)
- Audit log records delete workspace action properly (#8494)
- Audit logs are properly paginated (#8513)
- Fix bottom border on build logs (#8554)
- Don't mark metadata with `interval: 0` as stale (#8627)
- Add some missing workspace updates (#7790)

### Documentation

## Changelog

### Breaking changes

Agent logs can be pushed after a workspace has started (#8528)

> ⚠️ **Warning:** You will need to
> [update](https://coder.com/docs/v2/latest/install) your local Coder CLI v0.27
> to connect via `coder ssh`.

### Features

- [Empeheral parameters](https://registry.terraform.io/providers/coder/coder/latest/docs/data-sources/parameter#ephemeral)
  allow users to specify a value for a single build (#8415) (#8524)
  ![Ephemeral parameters](https://github.com/coder/coder/assets/22407953/89df0888-9abc-453a-ac54-f5d0e221b0b9)
  > Upgrade to Coder Terraform Provider v0.11.1 to use ephemeral parameters in
  > your templates
- Create template, if it doesn't exist with `templates push --create` (#8454)
- Workspaces now appear `unhealthy` in the dashboard and CLI if one or more
  agents do not exist (#8541) (#8548)
  ![Workspace health](https://github.com/coder/coder/assets/22407953/edbb1d70-61b5-4b45-bfe8-51abdab417cc)
- Reverse port-forward with `coder ssh -R` (#8515)
- Helm: custom command arguments in Helm chart (#8567)
- Template version messages (#8435)
  <img width="428" alt="252772262-087f1338-f1e2-49fb-81f2-358070a46484" src="https://github.com/coder/coder/assets/22407953/5f6e5e47-e61b-41f1-92fe-f624e92f8bd3">
- TTL and max TTL validation increased to 30 days (#8258)
- [Self-hosted docs](https://coder.com/docs/v2/latest/install/offline#offline-docs):
  Host your own copy of Coder's documentation in your own environment (#8527)
  (#8601)
- Add custom coder bin path for `config-ssh` (#8425)
- Admins can create workspaces for other users via the CLI (#8481)
- `coder_app` supports localhost apps running https (#8585)
- Base container image contains [jq](https://github.com/coder/coder/pull/8563)
  for parsing mounted JSON secrets

### Bug fixes

- Check agent metadata every second instead of minute (#8614)
- `coder stat` fixes
  - Read from alternate cgroup path (#8591)
  - Improve detection of container environment (#8643)
  - Unskip TestStatCPUCmd/JSON and explicitly set --host in test cmd invocation
    (#8558)
- Avoid initial license reconfig if feature isn't enabled (#8586)
- Audit log records delete workspace action properly (#8494)
- Audit logs are properly paginated (#8513)
- Fix bottom border on build logs (#8554)
- Don't mark metadata with `interval: 0` as stale (#8627)
- Add some missing workspace updates (#7790)

### Documentation

- Custom API use cases (custom agent logs, CI/CD pipelines) (#8445)
- Docs on using remote Docker hosts (#8479)
- Added kubernetes option to workspace proxies (#8533)

Compare:
[`v0.26.1...v0.26.2`](https://github.com/coder/coder/compare/v0.26.1...v0.27.0)

## Container image

- `docker pull ghcr.io/coder/coder:v0.26.2`

## Install/upgrade

Refer to our docs to [install](https://coder.com/docs/v2/latest/install) or
[upgrade](https://coder.com/docs/v2/latest/admin/upgrade) Coder, or use a
release asset below.

- Custom API use cases (custom agent logs, CI/CD pipelines) (#8445)
- Docs on using remote Docker hosts (#8479)
- Added kubernetes option to workspace proxies (#8533)

Compare:
[`v0.26.1...v0.26.2`](https://github.com/coder/coder/compare/v0.26.1...v0.27.0)

## Container image

- `docker pull ghcr.io/coder/coder:v0.26.2`

## Install/upgrade

Refer to our docs to [install](https://coder.com/docs/v2/latest/install) or
[upgrade](https://coder.com/docs/v2/latest/admin/upgrade) Coder, or use a
release asset below.
