## Changelog

### Features

- [External provisioners](https://coder.com/docs/v2/latest/admin/provisioners)
  updates
  - Added
    [PSK authentication](https://coder.com/docs/v2/latest/admin/provisioners#authentication)
    method (#8877) (@spikecurtis)
  - Provisioner daemons can be deployed
    [via Helm](https://github.com/coder/coder/tree/main/helm/provisioner)
    (#8939) (@spikecurtis)
- Added login type (OIDC, GitHub, or built-in, or none) to users page (#8912)
  (@Emyrk)
- Groups can be
  [automatically created](https://coder.com/docs/v2/latest/admin/auth#user-not-being-assigned--group-does-not-exist)
  from OIDC group sync (#8884) (@Emyrk)
- Parameter values can be specified via the
  [command line](https://coder.com/docs/v2/latest/cli/create#--parameter) during
  workspace creation/updates (#8898) (@mtojek)
- Added date range picker for the template insights page (#8976)
  (@BrunoQuaresma)
- We now publish preview
  [container images](https://github.com/coder/coder/pkgs/container/coder-preview)
  on every commit to `main`. Only use these images for testing. They are
  automatically deleted after 7 days.
- Coder is
  [officially listed JetBrains Gateway](https://coder.com/blog/self-hosted-remote-development-in-jetbrains-ides-now-available-to-coder-users).

### Bug fixes

- Don't close other web terminal or `coder_app` sessions during a terminal close
  (#8917)
- Properly refresh OIDC tokens (#8950) (@Emyrk)
- Added backoff to validate fresh git auth tokens (#8956) (@kylecarbs)
- Make preferred region the first in list (#9014) (@matifali)
- `coder stat`: clistat: accept positional arg for stat disk cmd (#8911)
- Prompt for confirmation during `coder delete <workspace>` (#8579)
- Ensure SCIM create user can unsuspend (#8916)
- Set correct Prometheus port in Helm notes (#8888)
- Show user avatar on group page (#8997) (@BrunoQuaresma)
- Make deployment stats bar scrollable on smaller viewports (#8996)
  (@BrunoQuaresma)
- Add horizontal scroll to template viewer (#8998) (@BrunoQuaresma)
- Persist search parameters when user has to authenticate (#9005)
  (@BrunoQuaresma)
- Set default color and display error on appearance form (#9004)
  (@BrunoQuaresma)

Compare:
[`v2.0.1...v2.0.2`](https://github.com/coder/coder/compare/v2.0.1...v2.0.2)

## Container image

- `docker pull ghcr.io/coder/coder:v2.0.2`

## Install/upgrade

Refer to our docs to [install](https://coder.com/docs/v2/latest/install) or
[upgrade](https://coder.com/docs/v2/latest/admin/upgrade) Coder, or use a
release asset below.
