## Changelog

### Important changes

- We removed `jq` from our base image. In the unlikely case you use `jq` for
  fetching Coder's database secret or other values, you'll need to build your
  own Coder image. Click
  [here](https://gist.github.com/bpmct/05cfb671d1d468ae3be46e93173a02ea) to
  learn more. (#8979) (@ericpaulsen)

### Features

- You can manually add OIDC or GitHub users (#9000) (@Emyrk)
  ![Manual add user](https://user-images.githubusercontent.com/22407953/261455971-adf2707c-93a7-49c6-be5d-2ec177e224b9.png)
  > Use this with the
  > [CODER_OIDC_ALLOW_SIGNUPS](https://coder.com/docs/v2/latest/cli/server#--oidc-allow-signups)
  > flag to manually onboard users before opening the floodgates to every user
  > in your identity provider!
- CLI: The
  [--header-command](https://coder.com/docs/v2/latest/cli#--header-command) flag
  can leverage external services to provide dynamic headers to authenticate to a
  Coder deployment behind an application proxy or VPN (#9059) (@code-asher)
- OIDC: Add support for Azure OIDC PKI auth instead of client secret (#9054)
  (@Emyrk)
- Helm chart updates:
  - Add terminationGracePeriodSeconds to provisioner chart (#9048)
    (@spikecurtis)
  - Add support for NodePort service type (#8993) (@ffais)
  - Published
    [external provisioner chart](https://coder.com/docs/v2/latest/admin/provisioners#example-running-an-external-provisioner-with-helm)
    to release and docs (#9050) (@spikecurtis)
- Exposed everyone group through UI. You can now set
  [quotas](https://coder.com/docs/v2/latest/admin/quotas) for the `Everyone`
  group. (#9117) (@sreya)
- Workspace build errors are shown as a tooltip (#9029) (@BrunoQuaresma)
- Add build log history to the build log page (#9150) (@BrunoQuaresma)
  ![Build log history](https://user-images.githubusercontent.com/22407953/261457020-3fbbb274-1e32-4116-affb-4a5ac271110b.png)

### Bug fixes

- Correct GitHub oauth2 callback url (#9052) (@Emyrk)
- Remove duplication from language of query param error (#9069) (@kylecarbs)
- Remove unnecessary newlines from the end of cli output (#9068) (@kylecarbs)
- Change dashboard route `/settings/deployment` to `/deployment` (#9070)
  (@kylecarbs)
- Use screen for reconnecting terminal sessions on Linux if available (#8640)
  (@code-asher)
- Catch missing output with reconnecting PTY (#9094) (@code-asher)
- Fix deadlock on tailnet close (#9079) (@spikecurtis)
- Rename group GET request (#9097) (@ericpaulsen)
- Change oauth convert oidc cookie to SameSite=Lax (#9129) (@Emyrk)
- Make PGCoordinator close connections when unhealthy (#9125) (@spikecurtis)
- Don't navigate away from editor after publishing (#9153) (@aslilac)
- /workspaces should work even if missing template perms (#9152) (@Emyrk)
- Redirect to login upon authentication error (#9134) (@aslilac)
- Avoid showing disabled fields in group settings page (#9154) (@ammario)
- Disable wireguard trimming (#9098) (@coadler)

### Documentation

- Add
  [offline docs](https://www.jetbrains.com/help/idea/fully-offline-mode.html)
  for JetBrains Gateway (#9039) (@ericpaulsen)
- Add `coder login` to CI docs (#9038) (@ericpaulsen)
- Expand [JFrog platform](https://coder.com/docs/v2/v2.1.0/platforms/jfrog) and
  example template (#9073) (@matifali)

## Container image

- `docker pull ghcr.io/coder/coder:v2.1.0`

## Install/upgrade

Refer to our docs to [install](https://coder.com/docs/v2/latest/install) or
[upgrade](https://coder.com/docs/v2/latest/admin/upgrade) Coder, or use a
release asset below.
