## Changelog

### Features

- Add `last_used` search params to workspaces. This can be used to find inactive
  workspaces (#9230) (@Emyrk)
  ![Last used](https://user-images.githubusercontent.com/22407953/262407146-06cded4e-684e-4cff-86b7-4388270e7d03.png)
  > You can use `last_used_before` and `last_used_after` in the workspaces
  > search with [RFC3339Nano](https://www.rfc-editor.org/rfc/rfc3339) datetime
- Add `daily_cost`` to `coder ls` to show
  [quota](https://coder.com/docs/v2/latest/admin/quotas) consumption (#9200)
  (@ammario)
- Added `coder_app` usage to template insights (#9138) (@mafredri)
  ![code-server usage](https://user-images.githubusercontent.com/22407953/262412524-180390de-b1a9-4d57-8473-c8774ec3fd6e.png)
- Added documentation for
  [workspace process logging](http://localhost:3000/docs/v2/latest/templates/process-logging).
  This enterprise feature can be used to log all system-level processes in
  workspaces. (#9002) (@deansheather)

### Bug fixes

- Avoid temporary license banner when Coder is upgraded via Helm + button to
  refresh license entitlements (#9155) (@Emyrk)
- Parameters in the page "Create workspace" will show the display name as the
  primary field (#9158) (@aslilac)
  ![Parameter order](https://user-images.githubusercontent.com/418348/261439836-e7e7d9bd-9204-42be-8d13-eae9a9afd17c.png)
- Fix race in PGCoord at startup (#9144) (@spikecurtis)
- Do not install strace on OSX (#9167) (@mtojek)
- Use proper link to workspace proxies page (#9183) (@bpmct)
- Correctly assess quota for stopped resources (#9201) (@ammario)
- Add workspace_proxy type to auditlog friendly strings (#9194) (@Emyrk)
- Always show add user button (#9229) (@aslilac)
- Correctly reject quota-violating builds (#9233) (@ammario)
- Log correct script timeout for startup script (#9190) (@mafredri)
- Remove prompt for immutable parameters on start and restart (#9173) (@mtojek)
- Server logs: apply filter to log message as well as name (#9232) (@ammario)

Compare:
[`v2.1.0...v2.1.1`](https://github.com/coder/coder/compare/v2.1.0...v2.1.1)

## Container image

- `docker pull ghcr.io/coder/coder:v2.1.1`

## Install/upgrade

Refer to our docs to [install](https://coder.com/docs/v2/latest/install) or
[upgrade](https://coder.com/docs/v2/latest/admin/upgrade) Coder, or use a
release asset below.
