## Changelog

### Features

- Add `template_active_version_id` to workspaces (#9226) (@kylecarbs)
- Show entity name in DeleteDialog (#9347) (@ammario)
- Improve template publishing flow (#9346) (@aslilac)

### Bug fixes

- Fixed 2 bugs contributing to a memory leak in `coderd` (#9364):
  - Allow `workspaceAgentLogs` follow to return on non-latest-build (#9382)
    (@mafredri)
  - Avoid derp-map updates endpoint leak (#9390) (@deansheather)
- Send updated workspace data after ws connection (#9392) (@BrunoQuaresma)
- Fix `coder template pull` on Windows (#9327) (@spikecurtis)
- Truncate websocket close error (#9360) (@kylecarbs)
- Add `--max-ttl`` to template create (#9319) (@ammario)
- Remove rate limits from agent metadata (#9308) (@ammario)
- Use `websocketNetConn` in `workspaceProxyCoordinate` to bind context (#9395)
  (@mafredri)
- Fox default ephemeral parameter value on parameters page (#9314)
  (@BrunoQuaresma)
- Render variable width unicode characters in terminal (#9259) (@ammario)
- Use WebGL renderer for terminal (#9320) (@ammario)
- 80425c32b fix(site): workaround: reload page every 3sec (#9387) (@mtojek)
- Make right panel scrollable on template editor (#9344) (@BrunoQuaresma)
- Use more reasonable restart limit for systemd service (#9355) (@bpmct)

Compare:
[`v2.1.3...v2.1.4`](https://github.com/coder/coder/compare/v2.1.3...v2.1.4)

## Container image

- `docker pull ghcr.io/coder/coder:v2.1.4`

## Install/upgrade

Refer to our docs to [install](https://coder.com/docs/v2/latest/install) or
[upgrade](https://coder.com/docs/v2/latest/admin/upgrade) Coder, or use a
release asset below.
