## Changelog

### Features

- Template admins can require users to authenticate with external services, besides git providers (#9996) (@kylecarbs)
  ![External auth](https://user-images.githubusercontent.com/22407953/272645210-ae197e8b-c012-4e2a-9c73-83f3d6616da6.png)
  > In a future release, we will provide a CLI command to fetch (and refresh) the OIDC token within a workspace.
- Users are now warned when renaming workspaces (#10023) (@aslilac)
- Add reverse tunnelling SSH support for unix sockets (#9976) (@monika-canva)
- Admins can set a custom application name and logo on the log in screen (#9902) (@mtojek)
  > This is an [Enterprise feature](https://coder.com/docs/v2/latest/enterprise).
- Add support for weekly active data on template insights (#9997) (@BrunoQuaresma)
  ![Weekly active users graph](https://user-images.githubusercontent.com/22407953/272647853-e9d6ca3e-aca4-4897-9be0-15475097d3a6.png)
- Add weekly user activity on template insights page (#10013) (@BrunoQuaresma)

### API changes

- API breaking change: report and interval_reports can be omitted in `api/v2/insights/templates` (#10010) (@mtojek)

### Bug fixes

- Users can optionally install `CAP_NET_ADMIN` on the agent and CLI to troubleshoot degraded network performance (#9908) (#9953) (@coadler)
- Add checks for preventing HSL colors from entering React state (#9893) (@Parkreiner)
- Fix TestCreateValidateRichParameters/ValidateString (#9928) (@mtojek)
- Pass `OnSubscribe` to HA MultiAgent (#9947) (@coadler)
  > This fixes a memory leak if you are running Coder in [HA](https://coder.com/docs/v2/latest/admin/high-availability).
- Remove exp scaletest from slim binary (#9934) (@johnstcn)
- Fetch workspace agent scripts and log sources using system auth ctx (#10043) (@johnstcn)
- Fix typo in pgDump (#10033) (@johnstcn)
- Fix double input box for logo url (#9926) (@mtojek)
- Fix navbar hover (#10021) (@BrunoQuaresma)
- Remove 48 week option (#10025) (@BrunoQuaresma)
- Fix orphan values on insights (#10036) (@BrunoQuaresma)

### Documentation

- Add support to enterprise features list (#10005) (@ericpaulsen)
- Update frontend contribution docs (#10028) (@Parkreiner)

---

Compare: [`v2.2.0...v2.2.1`](https://github.com/coder/coder/compare/v2.2.0...v2.2.1)

## Container image

- `docker pull ghcr.io/coder/coder:v2.2.1`

## Install/upgrade

Refer to our docs to [install](https://coder.com/docs/v2/latest/install) or [upgrade](https://coder.com/docs/v2/latest/admin/upgrade) Coder, or use a release asset below.
