## Changelog

### Features

- Make the dotfiles repository directory configurable for `coder dotfiles` (#10377) (@JoshVee)
- Expose template version to provisioner (#10306) (@JoshVee)

### Bug fixes

- Initialize terminal with correct size (#10369) (@code-asher)
- Disable tests broken by daylight savings (#10414) (@spikecurtis)
- Add new aws regions to instance identity (#10434) (@kylecarbs)
- Prevent infinite redirect oauth auth flow (#10430) (@Emyrk)
- Prevent metadata from being discarded if report is slow (#10386) (@mafredri)
- Track cron run and wait for cron stop (#10388) (@mafredri)
- Display informative error for ErrWaitDelay (#10407) (@mafredri)
- Avoid error log during shutdown (#10402) (@mafredri)
- Update installation link (#10275) (@devarshishimpi)

### Tests

- 8f1b4fb06 test(agent): fix service banner trim test flake (#10384) (@mafredri)
- 1286904de test(agent): improve TestAgent_Session_TTY_MOTD_Update (#10385) (@mafredri)
- eac155aec test(cli): fix TestServer flake due to DNS lookup (#10390) (@mafredri)
- 9d3785def test(cli/cliui): make agent tests more robust (#10415) (@mafredri)
- 6683ad989 test(coderd): fix TestWorkspaceBuild flake (#10387) (@mafredri)

### Continuous integration

- 39fbf74c7 ci: bump the github-actions group with 1 update (#10379) (@app/dependabot)
- 6b7858c51 ci: bump the github-actions group with 2 updates (#10420) (@app/dependabot)

### Chores

Compare: [`v2.3.2...v2.3.3`](https://github.com/coder/coder/compare/v2.3.2...v2.3.3)

## Container image

- `docker pull ghcr.io/coder/coder:v2.3.3`

## Install/upgrade

Refer to our docs to [install](https://coder.com/docs/v2/latest/install) or [upgrade](https://coder.com/docs/v2/latest/admin/upgrade) Coder, or use a release asset below.
