## Changelog

### BREAKING CHANGES

- Renaming workspaces is disabled by default to data loss. This can be re-enabled via a [server flag](https://coder.com/docs/v2/latest/cli/server#--allow-workspace-renames) (#11189) (@f0ssel)

### Features

- Allow templates to specify max_ttl or autostop_requirement (#10920) (@deansheather)
- Add server flag to disable user custom quiet hours (#11124) (@deansheather)
- Move [workspace proxies](https://coder.com/docs/v2/latest/admin/workspace-proxies) to GA (#11285) (@Emyrk)
- Add light theme (preview) (#11266) (@aslilac)
  ![Light theme preview](https://raw.githubusercontent.com/coder/coder/main/docs/changelogs/images/light-theme.png)
- Enable CSRF token header (#11283) (@Emyrk)
- Add support for OAuth2 Applications (#11197) (@code-asher)
- Add AWS EC2 devcontainer template (#11248) (@matifali)
- Add Google Compute engine devcontainer template (#11246) (@matifali)

### Bug fixes

- Do not archive .tfvars (#11208) (@mtojek)
- Correct perms for forbidden error in TemplateScheduleStore.Load (#11286) (@Emyrk)
- Avoid panic on nil connection (#11305) (@spikecurtis)
- Stop printing warnings on external provisioner daemon command (#11309) (@spikecurtis)
- Add CODER*PROVISIONER_DAEMON_LOG*\* options (#11279) (@johnstcn)
- Fix template editor filetree navigation (#11260) (@BrunoQuaresma)
- Fix error when loading workspaces with dormant (#11291) (@BrunoQuaresma)

### Documentation

- Add guides section (#11199) (@stirby)
- Improve structure for example templates (#9842) (@bpmct)
- Add guidelines for debugging group sync (#11296) (@bpmct)

Compare: [`v2.5.1...v2.6.0`](https://github.com/coder/coder/compare/v2.5.1...v2.6.0)

## Container image

- `docker pull ghcr.io/coder/coder:v2.6.0`

## Install/upgrade

Refer to our docs to [install](https://coder.com/docs/v2/latest/install) or [upgrade](https://coder.com/docs/v2/latest/admin/upgrade) Coder, or use a release asset below.
