# Community Templates

This is a list of templates and actions created by the community.

See [Getting Started](./README.md#getting-started) for how to use these
templates.

> If you have created a template, see one that's missing or one that's no longer
> maintained, please submit a pull request to improve this list. Thank you!

## Templates

- [ntimo/coder-hetzner-cloud-template](https://github.com/ntimo/coder-hetzner-cloud-template) -
  Setup a Hetzner Cloud instance as dev environment with or without vscode.
- [matifali/coder-templates](https://github.com/matifali/coder-templates) -
  Deeplearning with Jupyter Notebook/Lab and Matlab in browser.
- [m.lan/coder-templates](https://gitlab.com/m.lan/coder-templates) - Kubernetes
  template with DinD.
- [jsjoeio/coder-templates](https://github.com/jsjoeio/coder-templates) - Docker
  templates that prompt for dotfiles and base Docker image.
- [sharkymark/v2-templates](https://github.com/sharkymark/v2-templates) -
  Kubernetes, Docker, AWS, Google Cloud, Azure templates, videos, emoji links,
  and API examples.
- [bpmct/coder-templates](https://github.com/bpmct/coder-templates) -
  Kubernetes, OpenStack, podman, Docker, VM, AWS, Google Cloud, Azure templates.
- [kozmiknano/vscode-server-template](https://github.com/KozmikNano/vscode-server-template) -
  Run the full VS Code server within docker! (Built-in settings sync and
  Microsoft Marketplace enabled)
- [atnomoverflow/coder-template](https://github.com/atnomoverflow/coder-template) -
  Kubernetes template that install VS code server Rstudio jupyter and also set
  ssh access to gitlab (Works also on self managed gitlab).
- [sempie/coder-templates](https://github.com/sempie/coder-templates) - RStudio
  template on a path using NGINX in the workspace
- [sulo1337/coder-kubevirt-template](https://github.com/sulo1337/coder-kubevirt-template) -
  Kubevirt-based development environment which provisions KVM virtual machines
  as coder workspaces on top of a Kubernetes cluster.

## Automation

- [Update Coder Template](https://github.com/marketplace/actions/update-coder-template) -
  A GitHub action to automate coder template changes.
